ll.registerPlugin("雪碧的连锁采集", "雪碧的连锁采集", [1,0,0], { author: "雪碧桑" })

let config = JSON.parse(File.readFrom('plugins/Sprite\'s_Chain_Gather/config.json'));

mc.listen("onDestroyBlock", (player, block) => {
    if(!player.isSneaking)
        return;
    let item = player.getHand()
    let enchs = []
    if(item.isEnchanted) {
        let nbtEnchs = item.getNbt().getTag('tag').getTag('ench')
        for(let index = 0; index < nbtEnchs.getSize(); index++) {
            let nbtEnch = nbtEnchs.getTag(index)
            enchs.push({
                id: nbtEnch.getData("id"),
                level: nbtEnch.getData("lvl")
            })
        }
    }
    for(let subConfigIndex in config) {
        let subConfig = config[subConfigIndex]
        if(!subConfig.enable) {
            continue
        }
        for(let toolIndex in subConfig.tools) {
            let tool = subConfig.tools[toolIndex]
            if(tool === item.type) {
                for(let blockIndex in subConfig.blocks) {
                    let blockStr = subConfig.blocks[blockIndex]
                    if(blockStr === block.type) {
                        setTimeout(()=>{
                            chainGather(block, block.pos, subConfig.maxX, subConfig.maxY, subConfig.maxZ, subConfig.destroyDelay, item, player, enchs)
                        }, subConfig.destroyDelay)
                        break;
                    }
                }
                break;
            }
        }
    }
})

function chainGather(block, sourcePos, maxX, maxY, maxZ, destroyDelay, item, player, enchs) {
    let poses = [
        new IntPos(block.pos.x+1,block.pos.y,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y+1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y-1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y+1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y-1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y+1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y-1,block.pos.z,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y+1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y+1,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y-1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x,block.pos.y-1,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y+1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y+1,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y-1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x+1,block.pos.y-1,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y+1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y+1,block.pos.z-1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y-1,block.pos.z+1,block.pos.dimid),
        new IntPos(block.pos.x-1,block.pos.y-1,block.pos.z-1,block.pos.dimid)]

    for(let posIndex in poses) {
        let pos = poses[posIndex]
        let targetBlock = mc.getBlock(pos)
        if(targetBlock.type === block.type) {
            if(item.damage != item.maxDamage) {
                let unbreaking = 0
                for(let index in enchs) {
                    let ench = enchs[index]
                    if(ench.id === 17) {
                        unbreaking = ench.level
                        break
                    }
                }
                if(!player.isCreative && Math.random() < 1/(unbreaking+1)) {
                    item.setDamage(item.damage + 1)
                }
                player.refreshItems()
                targetBlock.destroy(!player.isCreative)
                if(Math.abs(pos.x - sourcePos.x) < maxX && Math.abs(pos.y - sourcePos.y) < maxY && Math.abs(pos.z - sourcePos.z) < maxZ) {
                    setTimeout(()=>{
                        chainGather(targetBlock, sourcePos, maxX, maxY, maxZ, destroyDelay, item, player, enchs)
                    }, destroyDelay)
                }
            } else {
                break;
            }
        }
    }
}
